;LIST P=16F88 ;f=inhx8m
;#include "P16F88.inc" 
LIST P=16F627 ;f=inhx8m
#include "P16F627.inc" 
#include "Bank.inc"
;  pwm daje oko 500 Hz ?????

; __config _CONFIG1,_BODEN_OFF&_WDT_OFF&_LVP_OFF&_MCLR_OFF&_PWRTE_ON&_INTRC_IO

__CONFIG _CP_OFF &_BODEN_ON &_PWRTE_ON &_WDT_OFF &_LVP_OFF &_MCLRE_OFF &_HS_OSC 

; __config _CONFIG1, _CP_OFF &_BODEN_ON &_PWRTE_ON &_WDT_OFF &_LVP_OFF &_MCLR_OFF &_INTRC_IO &_CCP1_RB3

cblock	0x20	
	pwm
	W_TEMP
	STATUS_TEMP
;	limit
	prvi
	drugi
	treci
	cetvrti
endc

;-------------------------------------------------------------------------;
; Dodjeljivanje naziva nekim brojevima pinova za njihovo lake koritenje ;
;-------------------------------------------------------------------------;

   #DEFINE   RB1	D'1'  ; port B - pin 7
   #DEFINE   RB2	D'2'  ; port B - pin 8
   #DEFINE   RB3	D'3'  ; port B - pin 9
; reset vector
;////////////////////////////////////////////////////////////////////
	ORG	0
	goto 	Glavni
; interrupt vector
;////////////////////////////////////////////////////////////////////
	ORG	4
	goto	Prekid
Prekid
	MOVWF	W_TEMP         ; spremi W u W_TEMP
	swapf	W_TEMP,1       ; zamijeni vanija 4 bita sa manje vanima --> W_TEMP
	SWAPF	STATUS,0       ; zamijeni vanija 4 bita sa manje vanima --> W
	MOVWF	STATUS_TEMP    ; kopiraj W u STATUS_temp bez promjene u STATUS-u
                           ; registri su spremljeni sa zamijenjenim MSb i LSb

	movf	prvi,0		; W=prvi
	SKPZ
	goto	prvi_
	movf	drugi,0		; W=drugi
	SKPZ
	goto	drugi_
	movf	treci,0		; W=treci
	SKPZ
	goto	treci_
	movf	cetvrti,0	; W=cetvrti
	SKPZ
	goto	cetvrti_
	movlw	d'1'		; W=1
	movwf	prvi
prvi_
	bcf		PORTB,RB2
	bsf		PORTB,RB1
	incf	pwm,1
	movf	pwm,0
;	sublw	limit
	sublw	d'125'
	SKPNZ
	goto	drugidalje
	movf	pwm,0
	goto	RESTORE
drugidalje
	movlw	d'1'		; W=1
	movwf	drugi
	clrf	prvi
drugi_
	bcf		PORTB,RB2
	bsf		PORTB,RB1
	decf	pwm,1
	movf	pwm,0
	SKPZ
	goto	RESTORE
	movlw	d'1'		; W=1
	movwf	treci
	clrf	drugi
	movf	pwm,0
	goto	RESTORE
treci_
	bcf		PORTB,RB1
	bsf		PORTB,RB2
	incf	pwm,1
	movf	pwm,0
;	sublw	limit
	sublw	d'125'
	SKPNZ
	goto	cetvrtidalje
	movf	pwm,0
	goto	RESTORE
cetvrtidalje
	movlw	d'1'		; W=1
	movwf	cetvrti
	clrf	treci
cetvrti_
	bcf		PORTB,RB1
	bsf		PORTB,RB2
	decf	pwm,1
	movf	pwm,0
	SKPZ
	goto	RESTORE
	movlw	d'1'		; W=1
	movwf	prvi
	clrf	cetvrti
	movf	pwm,0
	goto	RESTORE
		
RESTORE
	CALL	sinetbl
	MOVWF	CCPR1L	; POSTAVI DUTY CYCLE PREMA TABLICI

	SWAPF	STATUS_TEMP,0  ; pripremi status_temp
	MOVWF	STATUS         ; vrati STATUS_reg
	SWAPF	W_TEMP,0       ; zamijeni vanija 4 bita sa manje vanima --> W
	bcf		PIR1,TMR2IF   ; resetiraj TMR2IF interrupt flag
	RETFIE                ; vrati se iz interupta

Init
	MOVLW	0x07		; turn comparators off and enable
	MOVWF	CMCON		; pins for I/O functions
	MOVLW	b'00000000'	; PORTB kompletno izlazni
	TRIS	PORTB		; Port B je kompletno izlazni
	Bank1
	MOVLW	b'00110000'	; RA4, RA5 = input --> moze jer nema kristala
	TRIS	PORTA
	Bank0
	CLRF	CCP1CON		; CCP module je iskljuen
	CLRF	TMR2		; clear Timer0 register
	bcf		T2CON,T2CKPS0	; TMR2 prescaler = 1
	bcf		T2CON,T2CKPS1	; TMR2 prescaler = 1
	bsf		T2CON,TMR2ON	; ukljui TMR2 broja

	bsf		INTCON,GIE	; Global interupt enable
	bsf		INTCON,PEIE	; Periferal interupt enable
	Bank1
	bsf		PIE1,TMR2IE	; enable TMR2=PR2 match interrupt
	Bank0
	bcf		PIR1,TMR2IF	; resetiraj flag
;		INTCON	registar                
;      			GIE - bit 7 -> Global interrupt enable
;				INTE - bit 4 -> interrrupt on RB0/INT pin enable
;				INTF - bit 1 = 1 vanjski prekid na pinu RB0 se dogodio, flag je potrebno obrisati u programu
;							 = 0 nije se dogodio vanjski prekid
;      PIE1 registar : bit 1 TMR2IE = 1 enable TMR2=PR2 match interrupt
;									= 0 disable
;	   PIR1 registar : bit 1 TMR2IF = 1 ==> TMR2=PR2 dogaaj se dogodio, flag je potrebno obrisati u programu
;									= 0 TMR2<>PR2
;	OPTION registar: bit 6 	INTEDG = 1 prekid na rastuoj ivici RB0/INT pina
;									= 0 na padajuoj ivici vanjskog impulsa
	Bank1
;	movlw	d'39'	; set PWM period za 4 MHz
;	movlw	d'89'	; set PWM period za 8 MHz
	movlw	d'159'	; set PWM period za 16 MHz
	movwf	PR2
	Bank0

	movf	CCP1CON,W
	andlw	b'00110000'	; maskiraj 2 Duty Cycle bita
	iorlw	b'00001111'	;
	movwf	CCP1CON		; enable PWM mode

	bcf		CCP1CON, CCP1X
	bcf		CCP1CON, CCP1Y	; STAVI 8-BITNI PWM FIKSNO
	bsf		PORTB,RB1
	bcf		PORTB,RB2
	movlw	d'1'
	movwf	prvi
	clrf	drugi
	clrf	treci
	clrf	cetvrti
	RETURN

Glavni
	CALL	Init
	CLRF	pwm
	MOVF	pwm,0	; W=pwm
	CALL	sinetbl
	MOVWF	CCPR1L	; POSTAVI DUTY CYCLE PREMA TABLICI

Petlja1
	GOTO	Petlja1

sinetbl
	addwf	PCL,1	; pcl=pcl+w
	retlw	d'0'
	retlw	d'2'
	retlw	d'4'
	retlw	d'6'
	retlw	d'8'
	retlw	d'10'
	retlw	d'12'
	retlw	d'14'
	retlw	d'16'
	retlw	d'18'
	retlw	d'20'
	retlw	d'22'
	retlw	d'24'
	retlw	d'26'
	retlw	d'28'
	retlw	d'30'
	retlw	d'32'
	retlw	d'34'
	retlw	d'36'
	retlw	d'38'
	retlw	d'40'
	retlw	d'42'
	retlw	d'43'
	retlw	d'45'
	retlw	d'47'
	retlw	d'49'
	retlw	d'51'
	retlw	d'53'
	retlw	d'55'
	retlw	d'57'
	retlw	d'59'
	retlw	d'60'
	retlw	d'62'
	retlw	d'64'
	retlw	d'66'
	retlw	d'68'
	retlw	d'70'
	retlw	d'71'
	retlw	d'73'
	retlw	d'75'
	retlw	d'77'
	retlw	d'78'
	retlw	d'80'
	retlw	d'82'
	retlw	d'84'
	retlw	d'85'
	retlw	d'87'
	retlw	d'89'
	retlw	d'90'
	retlw	d'92'
	retlw	d'94'
	retlw	d'95'
	retlw	d'97'
	retlw	d'98'
	retlw	d'100'
	retlw	d'101'
	retlw	d'103'
	retlw	d'104'
	retlw	d'106'
	retlw	d'107'
	retlw	d'109'
	retlw	d'110'
	retlw	d'112'
	retlw	d'113'
	retlw	d'115'
	retlw	d'116'
	retlw	d'117'
	retlw	d'119'
	retlw	d'120'
	retlw	d'121'
	retlw	d'122'
	retlw	d'124'
	retlw	d'125'
	retlw	d'126'
	retlw	d'127'
	retlw	d'129'
	retlw	d'130'
	retlw	d'131'
	retlw	d'132'
	retlw	d'133'
	retlw	d'134'
	retlw	d'135'
	retlw	d'136'
	retlw	d'137'
	retlw	d'138'
	retlw	d'139'
	retlw	d'140'
	retlw	d'141'
	retlw	d'142'
	retlw	d'143'
	retlw	d'144'
	retlw	d'144'
	retlw	d'145'
	retlw	d'146'
	retlw	d'147'
	retlw	d'147'
	retlw	d'148'
	retlw	d'149'
	retlw	d'150'
	retlw	d'150'
	retlw	d'151'
	retlw	d'151'
	retlw	d'152'
	retlw	d'152'
	retlw	d'153'
	retlw	d'153'
	retlw	d'154'
	retlw	d'154'
	retlw	d'155'
	retlw	d'155'
	retlw	d'156'
	retlw	d'156'
	retlw	d'156'
	retlw	d'156'
	retlw	d'157'
	retlw	d'157'
	retlw	d'157'
	retlw	d'157'
	retlw	d'158'
	retlw	d'158'
	retlw	d'158'
	retlw	d'158'
	retlw	d'158'
	retlw	d'158'
	retlw	d'158'
END